

  #define Version "160603"
  // rajout buzzer sur sortie RA2    Freq= F(Light)/32
   
 #define Version "160531"
 #define Projet "18F46K22_UART1_LCD2119_TLS235.mcppi"

 //Niveau de sortie : Ee = 375 mW/cm2, lp = 670 nm => 250Khz
 // 3 750 W /M2    -> 250Khz
 // Coeff = 3750 / 250 000=  0.015
 #define Freq2Watt 0.015
 // rajout LCD2119 sur I2C1
 
 #define With_LCD2119
 #define LCD_ADR 0x74

//  #define Version "160528"
 // TSL235   80  100Khz en lumiere ambiante
 // >  280Khz avec eclairage par lampe Leds
 // fonctionne OK avec VDD= 3,3V ou VDD=5V
 // test avec montage aliment par Pickit2
 // la frequence ne change pas avec la tension d'alim VDD ( ou tres peu)
 
 // test capteur OK apres deboires sur lecture contenu compteur timer0
 // test capteur lumiere avec 18F46K22 pastille Violet fonc
 // avec FOSC interne 16Mhz et UART1 -> prolific
 // sous auim 3,3V via Pickit2
// #define Timer1_Low
// #define Version "160527"
 #define FOSC_INTERNE    // 16Mhz       UART1  19200bds
 
  //   ac:Pinout_18F46K22

// Project :  18F46K22_UART1_LCD2119_TLS235.mcppi
// source :  18F46k22_UART1_LCD2119_Test_TSL235_160531.c
// EEPROM :
// Mikroc V 6.62
// PIC18F46K22  5,0V ou 3,3 V
// FOSC=16 MHz

// UART RC6 RC7 ->Interface Prolific LTTL/USB  -> COM12 19200  -> PC XP  VBray 2014
// UART , C_String   C_Stdlib   Conversions , I2C
// EEPROM :   18F46K22_Uart1_LCD2119_3_3V_160311.ihex

/* Config bit  :P18F45K22_FOSC_16MHZ_No_PLL.cfgsch
CONFIG1H : $300001 : 0x0028
CONFIG2L : $300002 : 0x001F
CONFIG2H : $300003 : 0x003C
CONFIG3H : $300005 : 0x0099
CONFIG4L : $300006 : 0x0080
CONFIG5L : $300008 : 0x000F
CONFIG5H : $300009 : 0x00C0
CONFIG6L : $30000A : 0x000F
CONFIG6H : $30000B : 0x00E0
CONFIG7L : $30000C : 0x000F
CONFIG7H : $30000D : 0x0040



 hardware
I2C2      SCL sur RD0
I2C2      SDA sur RD1
I2C1      SCL sur RC3
I2C1      SDA sur RC4
TX        UART1 sur RC6
RX        UART1 sur RC7
RA0       Entree Analog
RA4       Sortie Led rouge   <-----  Pin3 TSL235
+         --------------------------- Pin 2
GNd       --------------------------- pin 1
RC6 ---------------- fil blanc -----------------Prolific USB
RC7 ---------------- fil vert -------------------
Gnd 0V --------------fil noir -------------------
                    N.C. rouge ------------------
*/

#include "built_in.h"     // for  Hi  Lo ..etc

#define PROCESSOR 18F46K22
#define POWER_SUPPLY_3_3V
#define FOSC 10.0  // MHz
#define BAUD 19200  // UART1
#define CLS 12
#define CR 13
#define LF 10
#define TAB 9
#define BACK 8
#define Separator 0x20   // space

#define NbCycles_T1 8       // nb d'interrupot pour faire 1 seconde

sbit Led_Rouge at LATA5_bit;
sbit Test_Freq at PORTC.B2;
sbit Freq_Input at PORTA.B4;
sbit Beeper at LATA2_bit;
sbit Beeper_direction  at TRISA2_bit;


const code char mesg0[]="Mikroc 6.62 18F46K22 UART1 \n\r";
const code char mesg1[]="18F46K22_UART1_LCD2119_TLS235.mcppi\r\n";
const code char mesg2[]="18F46k22_UART1_Test_TSL235_"Version".c \r\n";
const code char mesg3[]="FOSC interne 16Mhz \r\n";
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3};

#define MAXLEN1 200
volatile unsigned char buffer1[MAXLEN1];
volatile int Flag_Buffer1;
volatile  unsigned char c1;  
volatile unsigned int i1; 
volatile int Index1;
volatile unsigned int CptErr;



char received_data[16], ip_address[16];
//unsigned char tmp;
int UART2_DataReady;


static int Flag_Timer1;
static int Cpt1;
static int Max_Timer1;


int i,j,k,l,m;
unsigned  char TEXTE[64];
unsigned char * txt;
unsigned char *p;
char CRam1[32];   // for flot2asccii use
char Tampon[35];
unsigned int EAnx,EAn0,EAn1;
unsigned int SEAn0,SEAn1;
int nM;
unsigned char N1;
unsigned char  addr,donnee;
unsigned int Etat;
unsigned int clk;
unsigned long OverFlow_Timer0;
unsigned long TSL235;
unsigned int Freq;
 
float f1,f2,ff;

void Init_Hardware(void) ;
void Read_Msg_Eeprom( int depuis);
void Write_Msg_Eeprom( int Adr,const char * d1) ;

void Init_Timer1 (void);  //  timer 100mS * Max_timer1
void Arme_Timer1(void);   //
void Init_Timer0 (void);  //  counter in RA4 input
void strConstRamCpy(unsigned char *dest, const code char *source);
void UART1_Write_CText(const char *txt); 
void RAZ_UART1(void);
unsigned char *Float2Ascii (float x, unsigned char *chaine,char precision) ;
void CRLF1(void)  ;


void LCD_CLS(void);
void LCD_Clear(void); // <-- PB >> au lieu de space.. because  LCD avec ROM G
int LCD2119_Init(void);
void LCD_RAZ_Ligne(int L);
void LCD_Write_Chr_At(int Ligne,int Col,char c1) ;
void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1);
void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1);
void LCD_Write_CText(const char * t1);
void Cree_Euro(void) ;
void Cree_8_cars_CGRAM(void)  ;
void LCD_Cde(unsigned char Cde);
void LCD_Gauche(void);
void LCD_Droite(void);

void check_device(unsigned char dev_address);  // necessite liaison RS232 UART1









void Interrupt_High() iv 0x0008 ics ICS_AUTO
{
 if ( (RCIE_bit) && ( RCIF_bit))
   {
   // traitement separe des erreurs de COM
      c1 = RCREG;
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       RCSTA.CREN = 1 ;
        CptErr++;

       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG;
      }
     if ((c1==CR) || (i1 > MAXLEN1-2))
      {
      Flag_Buffer1=1;
      PIE1.RCIE=0 ; //interdit IT Reception UART
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        if (i1 > MAXLEN1-2)  Flag_Buffer1=2;
        buffer1[i1]=c1;
        Index1=i1;
        i1++;

      }
   }
    // comptage depassement Timer0
     if ((TMR0IE_bit) && (TMR0IF_bit) )
      {     TXREG1='*';
           OverFlow_Timer0++;
            TMR0IF_bit = 0;
       }
     // -----  timer 1  ----------------
  #ifndef Timer1_LOW
   if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     Cpt1++;
     //TXREG1='#';
     if (Cpt1 >=Max_Timer1)   // x100 ms
       {
        TMR0IE_bit=0; // stop comptage  timer0
        TMR0ON_bit=0;
        Cpt1=0;
        Flag_Timer1=1;
        TMR1ON_bit=0;

        TMR1IE_bit=0;
      }
      TMR1H= 0x0B; // Hi (3035);
      TMR1L= 0xDB; // Lo (3035);
      PIR1.TMR1IF=0;
   }
   #endif
 }
 
#ifdef Timer1_LOW
void Interrupt_LOW() iv 0x0018 ics ICS_AUTO
 {

  // -----  timer 1  ----------------
  if  ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
   {  // Test "Peripheral Interrupt Request Register 1" for Timer1 Flag
     Cpt1++;
     //TXREG1='#';
     if (Cpt1 >=Max_Timer1)   // x100 ms
       {
        TMR0IE_bit=0; // stop comptage  timer0
        Cpt1=0;
        Flag_Timer1=1;
        TMR1ON_bit=0;
        TMR1IE_bit=0;
      }
      TMR1H= 0x0B; // Hi (3035);
      TMR1L= 0xDB; // Lo (3035);
      PIR1.TMR1IF=0;
   }
 }
 #endif
 
 unsigned char EEPROM_Lect(unsigned int AdrL) // lecture a l'adresse adr
{
    EEADR =(unsigned char)(AdrL  &0x00FF);
    EEADRH =(unsigned char) ((AdrL >>8) & 0x0003);
    EECON1.EEPGD=0;     // 0= adressage EEPROM
    Delay_ms(1);
    EECON1.CFGS=0;      // 0= acces data EEPROM
    EECON1.RD=1;        // arme Lecture EEprom
    Delay_ms(20);;
    return(EEDATA);
}
 
 
 
 
 

// --- Copie le texte depuis FLASH ROM vers RAM
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
  while (*source)*dest++ = *source++ ;
  *dest = 0 ;    // terminateur
}

//#include "LCD2119.inc"


void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}

void UART1_Write_CText(const char *txt)
 {
   while (*txt)
      UART1_Write(*txt++);
}


void Write_Msg_Eeprom(int Adr,const char * d1)
{ int i1 ,i;
  char c1;
  i1=Adr;
  do
  {
  c1=*d1;
  EEPROM_Write(Adr,c1); 
  if ( c1==0) break;
  if ( i1>1023) break;
  Delay_ms(5);
  i1++;
  }
  while (i!=0) ;
 }
 
void Read_Msg_Eeprom( int debut,int fin)
{   int i1 ,i;
  i1=debut;
  do
  {
  i = EEPROM_Read(i1);
  if ( i==0) break;
  if ( i1>1023) break;
  if( i1>fin) break;
  UART1_Write(i);
  Tampon[i1-debut]=i;
  Delay_ms(5);
  i1++;
   }
  while (i!=0) ;
 }




 
void Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;                // a la place de =*
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
}


 void Init_Hardware()
{
  PORTA = 0b00010011;
  ANSELA=0;
  ANSELA.ANSA0=1;    //  analog input on Port A   voir page 154
  ANSELA.ANSA1=1;
  TRISA = 0b00010111 ;   // PORTA is RA0,1= analog input  RA2=sortie DAC RA3  RA4=Input  RA5,6=Digital output
  Beeper_direction=0;
  Beeper=0;

  CCP5CON=0;
  

  PORTB = 0xFF;
  TRISB = 0x83;    //  B0,B1 as input   ATTENTION B7 B6 for ICSP Pickit3
  ANSELB=0;

  PORTC = 0x00;          // RC0..RC5,RC7 = input RC6=Output
  ANSELC=0;
  TRISC = 0xFF;    //
  TRISC.TRISC7 = 1;  // RX - UART1
  TRISC.TRISC6 = 0;  // TX - UART1

  PORTD=0;
  ANSELD=0;
  TRISD=0xFF;
  TRISD.TRISD0 = 0;  // SCL I2C2
  TRISC.TRISD1 = 1;  // SDA I2C2
  TRISD.TRISD6 = 0;  // TX UART2
  TRISC.TRISD7 = 1;  // RX UART2

  SLRCON=0; // standard rate for PORTA,B,C,D,E
 }

void Init_ADC()
 {
       //config lecture ADC 10 bits
 ADCON0.ADON=1;      // ADC enabled chanel 0
 ADCON1.TRIGSEL=0 ; // trigger from CCP5
 ADCON2.ADFM=1;     // right justified
 ADCON2.ACQT2=1;
 ADCON2.ACQT1=1;
 ADCON2.ACQT0=0;    // 16 TAD
 ADCON2.ADCS1=1;    // select RA0 = analog input
 ADCON2.ADCS2=0;    // RA1 = Analog input
 ADCON2.ADCS0=0;    // Fosc/32
 ADCON1.PVCFG1=0;   // +Vref = +5V AVdd
 ADCON1.PVCFG0=0;
 ADCON1.NVCFG1=0;   // -Vref = Gnd AVss
 ADCON1.NVCFG0=0;
 }

void RAZ_UART1()
{
    for (i1=0;i1<MAXLEN1;i1++) buffer1[i1]=0;
    i1=0;
    Index1=0;
    c1=RC1REG;
    c1=0;
    Flag_Buffer1 =0;
    RC1IE_bit = 1;
}


void Init_Timer0(void)
{
   // init en compteur sur entree RA4
  T08BIT_bit=0; // mode 16 bits
  T0CS_bit=1;  // mode comptage sur pin T0CKI= RA4
  T0SE_bit=1; // front edge
  PSA_bit=1; //  1= Not use of prescaler => 1/1 , because, if used prescaler minimum is 1/2
  T0PS2_bit=0; // prescaler 1/2
  T0PS1_bit=0;
  T0PS0_bit=0;
  TMR0H = 0;
  TMR0L = 0;
  TMR0IP_bit=1;   // high priority
  TMR0IF_bit=0;
  TMR0IE_bit=1;
  OverFlow_Timer0=0;
  TMR0ON_bit=1;
}

void Arme_Timer1(void)
{
   // 100mS * Max_Timer1
  TMR1IF_bit         = 0;
  TMR1H         = 0x0B;
  TMR1L         = 0xDC;
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=1;     // Timer0 ON
  TMR1IE_bit= 1;
  }


void Init_Timer1(void)
 {
//FOSC=16Mhz  Prescaler 1:8; TMR1 Preload = 3035; Actual Interrupt Time : 125 ms
  T1CON         = 0x00;
  TMR1CS1_bit=0; // FOSC/4
  TMR1CS0_bit=0;
  T1RD16_bit=1;
  T1CKPS1_bit=1;  //Prescaler 1:8
  T1CKPS0_bit=1;
  TMR1H  = 0x0B;
  TMR1L  = 0xDC;
   TMR1IF_bit  = 0;
  #ifdef Timer1_LOW
  TMR1IP_bit=0;   // low level interrupt
  #else
  TMR1IP_bit=1;   // low level interrupt
  #endif
  Cpt1=0;
  Flag_Timer1=0;
  TMR1ON_bit=0;
  TMR1IE_bit =0;
}


unsigned long  Mesure_TSL235(void)
{ unsigned long L1  ;
   L1=0;
   Init_Timer1();
   Arme_Timer1();
   OverFlow_Timer0=0;
   TMR0H=0;
   TMR0L=0;
   TMR0IF_bit=0;
   TMR0IE_bit=1;
   TMR0ON_bit=1;
   while(Flag_Timer1==0);    // wait 1 seconde
   L1=(long)TMR0L +  (long)TMR0H *256 +  (OverFlow_Timer0 * 65536);
   return L1;
 }

void main()
{

  #ifdef FOSC_INTERNE
  OSCCON = 0b01110010  ; //0x72 ;     //Oscillateur  16Mhz
  //OSCCON = 0b01100010  ; //0x62 ;     //Oscillateur  8Mhz
  //OSCTUNE.PLLEN=1
  OSCTUNE=0;
  OSCTUNE.PLLEN=0;
  OSCCON2=0;
  while (OSCCON.HFIOFS==0); // wait stable oscillator
  #else
  // Q=20Mhz
  #endif
   Delay_ms(1000);

  Init_Hardware() ;
  Max_Timer1=8;
  Led_Rouge=0;

  UART1_Init(19200);
  Delay_ms(100);
  UART1_Write(CLS);   // Erase screen terminal  :it is an option on Vbray Terminal!
  Delay_ms(500);
  
  txt=&TEXTE[0];

    CRLF1();
  // presentation sur UART
  UART1_Write_CText ("Presentation : \r\n");
  UART1_Write_CText ("C:\_MikroC\_MesProjets_MikroC\_18F46K22_TSL235_light_sensor\r\n");
  UART1_Write_CText("Projet :"Projet"\r\n");
  UART1_Write_CText(Messages[0]);
  UART1_Write_CText(Messages[1]);
  UART1_Write_CText(Messages[2]) ;
  UART1_Write_CText(Messages[3]) ;
  Delay_ms(2000);
  CRLF1();

  
  
  UART1_Write('$'); UART1_Write('$'); UART1_Write('$');
  Delay_ms(800);
  clk = Clock_kHz();
  sprintf(txt,"\r\nClock initiale in Khz = %05u \r\n",clk);
  UART1_Write_Text(txt);

   I2C1_Init(400000);
  CRLF1();

    addr=0x74;
  check_device(addr)  ;
  CRLF1();
  // UART1_Write_CText("Init LCD 2119 2x16\r\n");
  k=LCD2119_Init();
  Delay_ms(50);
  LCD_CLS();
  Delay_ms(50);
  
   LCD_Write_CText_At(1,1,"18F46K22 F=16Mz");
   LCD_Write_CText_At(2,1,"LCD2119 en I2C1");
   Delay_ms(1500);  // sans ce delai ,les 3 premiers caracteres sont bouffes sur le LCD
   LCD_Write_CText_At(1,1,"MikroC 6.62 1605");
   Delay_ms(1000);


   //RC2IE_bit=1 ;
  RC1IE_bit=1 ;
  RC1IP_bit=1;
 // RC2IP_bit=1;
  #ifdef Timer1_LOW
  TMR1IP_bit=0;   // low level interrupt
  #else
  TMR1IP_bit=1;   // low level interrupt
  #endif

  TMR0IP_bit=1;
  PEIE_bit=1;
  RCON.IPEN = 1;       // enable priority levels  , car TMR1 => low interrupt
  PEIE_bit = 1;          // Enable Peripheral interrupt
  GIE_bit  = 1;         // Enable Global interrupt


   UART1_Write_CText("Init Timer1 8 x 125 msec soit 2 sec \r\n" );
   Max_Timer1=8;
   Init_Timer1();
   Arme_Timer1();
   TXREG1='$';
   CRLF1();
   while(Flag_Timer1==0);
   TXREG1='#';
   CRLF1();

   Max_Timer1=8;
   Init_Timer0();

   UART1_Write_CText("Usage du Compteur Timer0 pour Capture pulses Light sensor :\r\n" )  ;
   LCD_Write_CText_At(1,1,"TSL #          W");
   LCD_Write_CText_At(2,1,"F= xxxxxxxxxx Hz");
   
  Sound_Init(&PORTA,2); //Sound_Init(&PORTC, 3);

   
   j=0;
  do
  {


   TSL235=0;
   Init_Timer1();
   Arme_Timer1();
   OverFlow_Timer0=0;
   TMR0H=0;
   TMR0L=0;  
   TMR0IF_bit=0;
   TMR0IE_bit=1;
   TMR0ON_bit=1;
   Sound_Play(Freq>>2,950);
   while(Flag_Timer1==0) ;    // wait 1 seconde
   TSL235=(long)TMR0L +  (long)TMR0H *256 +  (OverFlow_Timer0 * 65536);
   // GROS PIEGE  IONS !!!  Lire d'abord TMRxL AVANt TMRxH
   //TSL235= (long)TMR0H *256 + (long)TMR0L +  (OverFlow_Timer0 * 65536);
   UART1_Write(' ');UART1_Write(j/10+48);UART1_Write(j%10+48); UART1_Write(' ');
   UART1_Write_CText("TSL235 Frequence pulses = " ) ;
   LongWordToStr(TSL235,txt);
   Freq=(unsigned int) (TSL235>>5);
   k=strlen(txt);
   LCD_Write_Text_At(2,4,txt);
   UART1_Write_Text(txt);UART1_Write(' ');UART1_Write('H');UART1_Write('z');

   j++;
   if (j>99)
   {
       // to do ....moyenne ?
       j=0;
   }
   // indice de progression j
   LCD_Write_Chr_At(1,6,j/10+48);
   LCD_Write_Chr_At(1,7,j%10+48);
   // Calcul et affichage puissance
   f1= (float)TSL235 * Freq2Watt;
   k=(unsigned int)f1;
   WordToStr(k,txt);
   LCD_Write_Text_At(1,10,txt);
   UART1_Write(TAB);
   UART1_Write_Text(txt); UART1_Write(' ');
   UART1_Write_CText("W par M2");
   CRLF1();

  }
   while(1);
 }

 
 /*12:12:11.921> 
12:12:11.984> Presentation :
12:12:11.984> C:_MikroC_MesProjets_MikroC_18F46K22_TSL235_light_sensor
12:12:12.046> Projet : 18F46K22_uart_for_Tests.mcppi
12:12:12.046> Mikroc 6.62 18F46K22 UART1
12:12:12.046> 18F46k22_UART1_Test_TSL235_160531.c
12:12:12.046> FOSC interne 16Mhz
12:12:14.046>
12:12:14.859> $$$
12:12:14.859> Clock initiale in Khz = 16000
12:12:14.859>
12:12:14.921> Device at adresse : 116 found OK
12:12:14.921>
12:12:18.109> Init Timer1 8 x 125 msec soit 2 sec
12:12:18.109> $
12:12:19.109> #
12:12:19.171> Usage du Compteur Timer0 pour Capture pulses Light sensor :
12:12:20.234>  00 TSL235 Frequence pulses =      52393 Hz          785 W par M2
12:12:23.234>  01 TSL235 Frequence pulses =      52702 Hz          790 W par M2
12:12:26.296>  02 TSL235 Frequence pulses =      51468 Hz          772 W par M2
12:12:29.359>  03 TSL235 Frequence pulses =      33283 Hz          499 W par M2


0 1 mikroCPIC1618.exe -MSF -DBG -pP18F46K22 -LHF -C -Y -O11111114 -fo16 -N"C:\_MikroC\_MesProjets_MikroC\_18F46K22_TSL235_light_sensor\18F46K22_UART1_LCD2119_TLS235.mcppi" -EH"C:\_MikroC\_MesProjets_MikroC\_18F46K22_TSL235_light_sensor\18F46k22_UART1_LCD4x20_I2C2_EEPROM.ihex" -SP"C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"C:\_MikroC\mikroC PRO for PIC\uses\P18\" -SP"C:\_MikroC\_MesProjets_MikroC\_18F46K22_TSL235_light_sensor\" -SP"C:\_MikroC\_MesProjets_MikroC\common\" "LCD_2119_I2C_1605.c" "18F46k22_UART1_LCD2119_Test_TSL235_160531.c" "__Lib_Math.mcl" "__Lib_MathDouble.mcl" "__Lib_System.mcl" "__Lib_Delays.mcl" "__Lib_CType.mcl" "__Lib_CString.mcl" "__Lib_CStdlib.mcl" "__Lib_CMath.mcl" "__Lib_Conversions.mcl" "__Lib_Sprintf.mcl" "__Lib_PrintOut.mcl" "__Lib_ADC_A_D.mcl" "__Lib_EEPROM_1024.mcl" "__Lib_I2C_c34d01.mcl" "__Lib_UART_c67d67.mcl"
0 1139 Available RAM: 3875 [bytes], Available ROM: 65536 [bytes]
0 122 Compilation Started LCD_2119_I2C_1605.c
427 123 Compiled Successfully LCD_2119_I2C_1605.c
41 1164 Variable 'j' has been eliminated by optimizer LCD_2119_I2C_1605.c
0 122 Compilation Started 18F46k22_UART1_LCD2119_Test_TSL235_160531.c
0 1004 interrupt handler (Interrupt_High at 0x0008) 18F46k22_UART1_LCD2119_Test_TSL235_160531.c
524 1509 Generated baud rate is 19231 bps (error = 0.16 percent) 18F46k22_UART1_LCD2119_Test_TSL235_160531.c
652 123 Compiled Successfully 18F46k22_UART1_LCD2119_Test_TSL235_160531.c
489 1164 Variable 'L1' has been eliminated by optimizer 18F46k22_UART1_LCD2119_Test_TSL235_160531.c
0 127 All files Compiled in 141 ms
0 1144 Used RAM (bytes): 438 (11%)  Free RAM (bytes): 3437 (89%) Used RAM (bytes): 438 (11%)  Free RAM (bytes): 3437 (89%)
0 1144 Used ROM (bytes): 20842 (32%)  Free ROM (bytes): 44694 (68%) Used ROM (bytes): 20842 (32%)  Free ROM (bytes): 44694 (68%)
0 125 Project Linked Successfully 18F46K22_UART1_LCD2119_TLS235.mcppi
0 128 Linked in 78 ms
0 129 Project '18F46K22_UART1_LCD2119_TLS235.mcppi' completed: 234 ms
0 103 Finished successfully: 31 mai 2016, 16:52:32 18F46K22_UART1_LCD2119_TLS235.mcppi

*/