#line 1 "C:/_MikroC/_MesProjets_MikroC/_18F46K22_TSL235_light_sensor/18F46k22_UART1_Test_TSL235_160529.c"
#line 1 "c:/_mikroc/mikroc pro for pic/include/built_in.h"
#line 79 "C:/_MikroC/_MesProjets_MikroC/_18F46K22_TSL235_light_sensor/18F46k22_UART1_Test_TSL235_160529.c"
sbit Led_Rouge at LATA5_bit;

sbit CH_PD at LATA2_bit;
sbit GPIO15 at LATA4_bit;
sbit CH_PD_Direction at LATA2_bit;
sbit GPIO15_Direction at LATA4_bit;

const code char mesg0[]="Mikroc 6.62 18F46K22 UART1 \n\r";
const code char mesg1[]="18F46k22_UART1_Test_TSL235_" "160529" ".c \r\n";
const code char mesg2[]="Test capteur de lumiere TSL235 \r\n";
const code char * Messages[]={mesg0,mesg1,mesg2};


volatile unsigned char buffer1[ 200 ];
volatile int Flag_Buffer1;
volatile unsigned char c1;
volatile unsigned int i1;
volatile int Index1;
volatile unsigned int CptErr;



char received_data[16], ip_address[16];

int UART2_DataReady;


static int Flag_Timer1;
static int Cpt1;
static int Max_Timer1;


int i,j,k,l,m;
unsigned char TEXTE[64];
unsigned char * txt;
unsigned char *p;
char CRam1[32];
char Tampon[35];
unsigned int EAnx,EAn0,EAn1;
unsigned int SEAn0,SEAn1;
int nM;
unsigned char N1;
unsigned char addr,donnee;
unsigned int Etat;
unsigned int clk;
unsigned long OverFlow_Timer0;
unsigned long TSL235;

float f1,f2,ff;

void Init_Hardware(void) ;
void Read_Msg_Eeprom( int depuis);
void Write_Msg_Eeprom( int Adr,const char * d1) ;

void Init_Timer1 (void);
void Arme_Timer1(void);
void Init_Timer0 (void);
void strConstRamCpy(unsigned char *dest, const code char *source);
void UART1_Write_CText(const char *txt);
void RAZ_UART1(void);
unsigned char *Float2Ascii (float x, unsigned char *chaine,char precision) ;
void CRLF1(void) ;


void LCD_CLS(void);
void LCD_Clear(void);
int LCD2119_Init(void);
void LCD_RAZ_Ligne(int L);
void LCD_Write_Chr_At(int Ligne,int Col,char c1) ;
void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1);
void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1);
void LCD_Write_CText(const char * t1);
void Cree_Euro(void) ;
void Cree_8_cars_CGRAM(void) ;
void LCD_Cde(unsigned char Cde);
void LCD_Gauche(void);
void LCD_Droite(void);

void check_device(unsigned char dev_address);









void Interrupt_High() iv 0x0008 ics ICS_AUTO
{
 if ( (RCIE_bit) && ( RCIF_bit))
 {

 c1 = RCREG;
 if (RCSTA.OERR==1)
 {
 RCSTA.CREN = 0 ;
 c1 = RCREG;
 RCSTA.CREN = 1 ;
 CptErr++;

 }
 if(RCSTA.FERR==1 )
 {
 RCSTA.SPEN = 0 ;
 RCSTA.SPEN= 1 ;
 CptErr++;
 c1 = RCREG;
 }
 if ((c1== 13 ) || (i1 >  200 -2))
 {
 Flag_Buffer1=1;
 PIE1.RCIE=0 ;
 buffer1[i1]=0;
 Index1=i1;
 i1=0;
 c1=0;
 }
 else
 {
 if (i1 >  200 -2) Flag_Buffer1=2;
 buffer1[i1]=c1;
 Index1=i1;
 i1++;

 }
 }

 if ((TMR0IE_bit) && (TMR0IF_bit) )
 { TXREG1='*';
 OverFlow_Timer0++;
 TMR0IF_bit = 0;
 }


 if ( (TMR1IE_bit==1) && ( TMR1IF_bit==1))
 {
 Cpt1++;

 if (Cpt1 >=Max_Timer1)
 {
 TMR0IE_bit=0;
 TMR0ON_bit=0;
 Cpt1=0;
 Flag_Timer1=1;
 TMR1ON_bit=0;

 TMR1IE_bit=0;
 }
 TMR1H= 0x0B;
 TMR1L= 0xDB;
 PIR1.TMR1IF=0;
 }

 }
#line 260 "C:/_MikroC/_MesProjets_MikroC/_18F46K22_TSL235_light_sensor/18F46k22_UART1_Test_TSL235_160529.c"
void strConstRamCpy(unsigned char *dest, const code char *source)
 {
 while (*source)*dest++ = *source++ ;
 *dest = 0 ;
}




void CRLF1()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
}

void UART1_Write_CText(const char *txt)
 {
 while (*txt)
 UART1_Write(*txt++);
}


void Write_Msg_Eeprom(int Adr,const char * d1)
{ int i1 ,i;
 char c1;
 i1=Adr;
 do
 {
 c1=*d1;
 EEPROM_Write(Adr,c1);
 if ( c1==0) break;
 if ( i1>1023) break;
 Delay_ms(5);
 i1++;
 }
 while (i!=0) ;
 }

void Read_Msg_Eeprom( int debut)
{ int i1 ,i;
 i1=debut;
 do
 {
 i = EEPROM_Read(i1);
 if ( i==0) break;
 if ( i1>1023) break;
 UART1_Write(i);
 Tampon[i1-debut]=i;
 Delay_ms(5);
 i1++;
 }
 while (i!=0) ;
 }


void Float2Ascii (float x, unsigned char *str,char precision)
{


 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;

 if ( x < 0)
 {
 *str++ = '-';
 x = -x;
 }

 if (x > 0.0) while (x < 1.0)
 {
 x *= 10.0;
 ie--;
 }
 while (x >= 10.0)
 {
 x = x/10.0;
 ie++;
 }

 ndig += ie;


 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
 *str++ = '0'; *str++ = '.';
 if (ndig < 0) ie = ie-ndig;
 for (i = -1; i > ie; i--) *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
 k = x;
 *str++ = k + '0';
 if (i == ie ) *str++ = '.';
 x -= (y=k);
 x *= 10.0;
 }
 *str = '\0';
}


 void Init_Hardware()
{
 PORTA = 0b00010011;
 ANSELA=0;
 ANSELA.ANSA0=1;
 ANSELA.ANSA1=1;
 TRISA = 0b00010111 ;
 PORTA=0;
 CCP5CON=0;


 PORTB = 0xFF;
 TRISB = 0x83;
 ANSELB=0;

 PORTC = 0x00;
 ANSELC=0;
 TRISC = 0xFF;
 TRISC.TRISC7 = 1;
 TRISC.TRISC6 = 0;

 PORTD=0;
 ANSELD=0;
 TRISD=0xFF;
 TRISD.TRISD0 = 0;
 TRISC.TRISD1 = 1;
 TRISD.TRISD6 = 0;
 TRISC.TRISD7 = 1;

 SLRCON=0;
 }

void Init_ADC()
 {

 ADCON0.ADON=1;
 ADCON1.TRIGSEL=0 ;
 ADCON2.ADFM=1;
 ADCON2.ACQT2=1;
 ADCON2.ACQT1=1;
 ADCON2.ACQT0=0;
 ADCON2.ADCS1=1;
 ADCON2.ADCS2=0;
 ADCON2.ADCS0=0;
 ADCON1.PVCFG1=0;
 ADCON1.PVCFG0=0;
 ADCON1.NVCFG1=0;
 ADCON1.NVCFG0=0;
 }

void RAZ_UART1()
{
 for (i1=0;i1< 200 ;i1++) buffer1[i1]=0;
 i1=0;
 Index1=0;
 c1=RC1REG;
 c1=0;
 Flag_Buffer1 =0;
 RC1IE_bit = 1;
}


void Init_Timer0(void)
{

 T08BIT_bit=0;
 T0CS_bit=1;
 T0SE_bit=1;
 PSA_bit=1;
 T0PS2_bit=0;
 T0PS1_bit=0;
 T0PS0_bit=0;
 TMR0H = 0;
 TMR0L = 0;
 TMR0IP_bit=1;
 TMR0IF_bit=0;
 TMR0IE_bit=1;
 OverFlow_Timer0=0;
 TMR0ON_bit=1;
}

void Arme_Timer1(void)
{

 TMR1IF_bit = 0;
 TMR1H = 0x0B;
 TMR1L = 0xDC;
 Cpt1=0;
 Flag_Timer1=0;
 TMR1ON_bit=1;
 TMR1IE_bit= 1;
 }


void Init_Timer1(void)
 {

 T1CON = 0x00;
 TMR1CS1_bit=0;
 TMR1CS0_bit=0;
 T1RD16_bit=1;
 T1CKPS1_bit=1;
 T1CKPS0_bit=1;
 TMR1H = 0x0B;
 TMR1L = 0xDC;
 TMR1IF_bit = 0;



 TMR1IP_bit=1;

 Cpt1=0;
 Flag_Timer1=0;
 TMR1ON_bit=0;
 TMR1IE_bit =0;
}

void main()
{


 OSCCON = 0b01110010 ;


 OSCTUNE=0;
 OSCTUNE.PLLEN=0;
 OSCCON2=0;
 while (OSCCON.HFIOFS==0);
#line 497 "C:/_MikroC/_MesProjets_MikroC/_18F46K22_TSL235_light_sensor/18F46k22_UART1_Test_TSL235_160529.c"
 Delay_ms(1000);

 Init_Hardware() ;
 Max_Timer1=8;
 Led_Rouge=0;

 UART1_Init(19200);
 Delay_ms(100);
 UART1_Write( 12 );
 Delay_ms(500);

 txt=&TEXTE[0];

 CRLF1();

 UART1_Write_CText ("Presentation : \r\n");
 UART1_Write_CText("Projet : 18F46K22_uart_for_Tests.mcppi\r\n");
 UART1_Write_CText(Messages[0]);
 UART1_Write_CText(Messages[1]);
 UART1_Write_CText(Messages[2]) ;

 Delay_ms(2000);
 CRLF1();



 UART1_Write('$'); UART1_Write('$'); UART1_Write('$');
 Delay_ms(800);
 clk = Clock_kHz();
 sprintf(txt,"\r\nClock initiale in Khz = %05u \r\n",clk);
 UART1_Write_Text(txt);

 I2C1_Init(400000);
 CRLF1();

 addr=0x74;
 check_device(addr) ;
 CRLF1();

 k=LCD2119_Init();
 Delay_ms(50);
 LCD_CLS();
 Delay_ms(50);

 LCD_Write_CText_At(1,1,"18F46K22 F=16Mz");
 LCD_Write_CText_At(2,1,"LCD2119 en I2C1");
 Delay_ms(1500);
 LCD_Write_CText_At(1,1,"MikroC 6.62 1605");
 Delay_ms(1000);



 RC1IE_bit=1 ;
 RC1IP_bit=1;




 TMR1IP_bit=1;


 TMR0IP_bit=1;
 PEIE_bit=1;
 RCON.IPEN = 1;
 PEIE_bit = 1;
 GIE_bit = 1;


 UART1_Write_CText("Init Timer1 8 x 125 msec soit 2 sec \r\n" );
 Max_Timer1=8;
 Init_Timer1();
 Arme_Timer1();
 TXREG1='$';
 CRLF1();
 while(Flag_Timer1==0);
 TXREG1='#';
 CRLF1();

 Max_Timer1=8;
 Init_Timer0();

 LCD_Write_CText_At(1,1,"TSL235 Light #  ");
 LCD_Write_CText_At(2,1,"F= xxxxxxxxxx Hz");
#line 603 "C:/_MikroC/_MesProjets_MikroC/_18F46K22_TSL235_light_sensor/18F46k22_UART1_Test_TSL235_160529.c"
 j=0;
 do
 {
 TSL235=0;
 UART1_Write_CText("Init Timer1 et Compteur Timer0 pour Capture pulses Light sensor :\r\n" ) ;

 Init_Timer1();
 Arme_Timer1();

 OverFlow_Timer0=0;
 TMR0H=0;
 TMR0L=0;
 TMR0IF_bit=0;
 TMR0IE_bit=1;
 TMR0ON_bit=1;

 while(Flag_Timer1==0);
 TSL235=(long)TMR0L + (long)TMR0H *256 + (OverFlow_Timer0 * 65536);


 UART1_Write_CText("TSL235 Frequence pulses = " ) ;
 LongWordToStr(TSL235,txt);
 UART1_Write_Text(txt);UART1_Write(' ');UART1_Write('H');UART1_Write('z');
 CRLF1();
 j++;
 if (j>99)
 {

 j=0;
 }
 LCD_Write_Chr_At(1,15,j/10+48);
 LCD_Write_Chr_At(1,16,j%10+48);
 k=strlen(txt);
 LCD_Write_Text_At(2,4,txt);
 Delay_ms(2000);
 }
 while(1);

 }
